VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-------------------------------------------------------------------
'Description:
'Class to add one icon to the system tray.
'
'Creator:
'Alexandre Wendt Shima
'alexandre_shima@hotmail.com
'01/2000
'Curitiba - PR
'Brasil
'Modified 3/2000 by James E. Toebes j_toebes@yahoo.com
'-------------------------------------------------------------------

Option Explicit

Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pNid As NOTIFYICONDATA) As Boolean

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2

Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4

Public Enum TrayActions
    WM_MOUSEMOVE = &H200
    WM_LBUTTONDOWN = &H201
    WM_LBUTTONUP = &H202
    WM_LBUTTONDBLCLK = &H203
    WM_RBUTTONDOWN = &H204
    WM_RBUTTONUP = &H205
    WM_RBUTTONDBLCLK = &H206
End Enum

Private Type NOTIFYICONDATA
    lSize As Long
    hwnd As Long
    lId As Long
    lFlags As Long
    lCallBackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

Private mNID As NOTIFYICONDATA

Private WithEvents mPic As PictureBox
Attribute mPic.VB_VarHelpID = -1

Public Event TrayEvent(Button As TrayActions)

Private Sub Class_Initialize()
    With mNID
        .lSize = Len(mNID)
        .lCallBackMessage = WM_MOUSEMOVE
        .lFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .lId = 1&
    End With
End Sub

Private Sub Class_Terminate()
    DeleteIcon
    Set mPic = Nothing
End Sub

Public Property Let PicBox(ByVal PicBox As PictureBox)
    Set mPic = PicBox
    
    With mNID
        .hwnd = mPic.hwnd
        .hIcon = mPic
    End With
End Property

Public Property Get TipText() As String
    TipText = mNID.szTip
End Property

Public Property Let TipText(ByVal TipText As String)
    mNID.szTip = TipText & Chr$(0)
    Shell_NotifyIcon NIM_MODIFY, mNID
End Property

Public Function ShowIcon() As Boolean
    If mPic Is Nothing Then
        ShowIcon = False
    Else
        Shell_NotifyIcon NIM_ADD, mNID
        ShowIcon = True
    End If
End Function

Public Sub DeleteIcon()
    Shell_NotifyIcon NIM_DELETE, mNID
End Sub

Private Sub mPic_Change()
    mNID.hIcon = mPic
    Shell_NotifyIcon NIM_MODIFY, mNID
End Sub

Private Sub mPic_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Mouse move returns an encoded message of activity
    Static bRec As Boolean
    Dim lMsg    As TrayActions

    'Do not process recursivly
    If Not bRec Then
        'Set as processing
        bRec = True

        'Determine actual message
        lMsg = X / Screen.TwipsPerPixelX
        
        'limit to valid events
        If (lMsg >= WM_MOUSEMOVE) And (lMsg <= WM_RBUTTONDBLCLK) Then
            RaiseEvent TrayEvent(lMsg)
        End If

        'Clear Processing
        bRec = False
    End If
End Sub

